# TODO: tests (BR: kmod-devel >= 18, udev-devel >= 1:215, glib2-devel >= 1:2.50 for library; bats for tools; catch2 for C++)
#
# Conditional build:
%bcond_without	apidocs		# Doxygen API documentation
%bcond_without	python		# Python binding
%bcond_without	static_libs	# static libraries
#
Summary:	Library and tools for interacting with the Linux GPIO character device
Summary(pl.UTF-8):	Biblioteka i narzędzia do obsługi linuksowych urządzeń znakowych GPIO
Name:		libgpiod
Version:	1.6.4
Release:	1
License:	LGPL v2.1+
Group:		Libraries
Source0:	https://www.kernel.org/pub/software/libs/libgpiod/%{name}-%{version}.tar.xz
# Source0-md5:	7a2cca6ead9296c27e877070dd8853bc
URL:		https://git.kernel.org/pub/scm/libs/libgpiod/libgpiod.git/
%{?with_apidocs:BuildRequires:	doxygen}
BuildRequires:	help2man
BuildRequires:	libstdc++-devel >= 6:4.7
BuildRequires:	linux-libc-headers >= 6:5.5
%{?with_python:BuildRequires:	python3-devel >= 1:3.2}
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Since Linux 4.8 the GPIO sysfs interface is deprecated. User space
should use the character device instead. This library encapsulates the
ioctl calls and data structures behind a straightforward API.

%description -l pl.UTF-8
Od wersja Linuksa 4.8 interfejs sysfs do GPIO jest przestarzały.
Przestrzeń użytkownika powinna zamiast niego używać urządzenia
znakowego. Ta biblioteka kryje wywołania ioctl i struktury danych za
bezpośrednim API.

%package devel
Summary:	Header files for libgpiod library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki libgpiod
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for libgpiod library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki libgpiod.

%package static
Summary:	Static libgpiod library
Summary(pl.UTF-8):	Statyczna biblioteka libgpiod
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static libgpiod library.

%description static -l pl.UTF-8
Statyczna biblioteka libgpiod.

%package cxx
Summary:	C++ binding for libgpiod library
Summary(pl.UTF-8):	Interfejs C++ do biblioteki libgpiod
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description cxx
High-level, object-oriented C++ binding for libgpiod library.

%description cxx -l pl.UTF-8
Wysokopoziomowy, zorientowany obiektowo interfejs C++ do biblioteki
libgpiod.

%package cxx-devel
Summary:	Header files for libgpiodcxx library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki libgpiodcxx
Group:		Development/Libraries
Requires:	%{name}-cxx = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}
Requires:	libstdc++-devel >= 6:4.7

%description cxx-devel
Header files for libgpiodcxx library.

%description cxx-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki libgpiodcxx.

%package cxx-static
Summary:	Static libgpiodcxx library
Summary(pl.UTF-8):	Statyczna biblioteka libgpiodcxx
Group:		Development/Libraries
Requires:	%{name}-cxx-devel = %{version}-%{release}

%description cxx-static
Static libgpiodcxx library.

%description cxx-static -l pl.UTF-8
Statyczna biblioteka libgpiodcxx.

%package -n python3-gpiod
Summary:	Pythona binding for libgpiod library
Summary(pl.UTF-8):	Interfejs Pythona do biblioteki libgpiod
Group:		Libraries/Python
Requires:	%{name} = %{version}-%{release}

%description -n python3-gpiod
High-level, object-oriented Python binding for libgpiod library.

%description -n python3-gpiod -l pl.UTF-8
Wysokopoziomowy, zorientowany obiektowo interfejs Pythona do
biblioteki libgpiod.

%package apidocs
Summary:	API documentation for libgpiod library
Summary(pl.UTF-8):	Dokumentacja API biblioteki libgpiod
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for libgpiod library.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki libgpiod.

%prep
%setup -q

%build
%configure \
	%{!?with_static_libs:--disable-static} \
	--enable-bindings-cxx \
	%{?with_python:--enable-bindings-python} \
	--disable-silent-rules \
	--enable-tools
%{__make}

%if %{with apidocs}
%{__make} doc
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libgpiod*.la
%if %{with python}
%{__rm} $RPM_BUILD_ROOT%{py3_sitedir}/gpiod.la \
	%{?with_static_libs:$RPM_BUILD_ROOT%{py3_sitedir}/gpiod.a}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	cxx -p /sbin/ldconfig
%postun	cxx -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc NEWS README
%attr(755,root,root) %{_bindir}/gpiodetect
%attr(755,root,root) %{_bindir}/gpiofind
%attr(755,root,root) %{_bindir}/gpioget
%attr(755,root,root) %{_bindir}/gpioinfo
%attr(755,root,root) %{_bindir}/gpiomon
%attr(755,root,root) %{_bindir}/gpioset
%attr(755,root,root) %{_libdir}/libgpiod.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgpiod.so.2
%{_mandir}/man1/gpiodetect.1*
%{_mandir}/man1/gpiofind.1*
%{_mandir}/man1/gpioget.1*
%{_mandir}/man1/gpioinfo.1*
%{_mandir}/man1/gpiomon.1*
%{_mandir}/man1/gpioset.1*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgpiod.so
%{_includedir}/gpiod.h
%{_pkgconfigdir}/libgpiod.pc

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libgpiod.a
%endif

%files cxx
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgpiodcxx.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgpiodcxx.so.1

%files cxx-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgpiodcxx.so
%{_includedir}/gpiod.hpp
%{_pkgconfigdir}/libgpiodcxx.pc

%if %{with static_libs}
%files cxx-static
%defattr(644,root,root,755)
%{_libdir}/libgpiodcxx.a
%endif

%if %{with python}
%files -n python3-gpiod
%defattr(644,root,root,755)
%attr(755,root,root) %{py3_sitedir}/gpiod.so
%endif

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc doc/html/*
%endif
%changelog
* Thu Mar 30 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libgpiod.git;a=log;h=master

* Thu Mar 30 2023 Jakub Bogusz <qboosh@pld-linux.org> 93ed0a4
- updated to 1.6.4

* Wed Feb 01 2023 Arkadiusz Miśkiewicz <arekm@maven.pl> 3d9ccbf
- Release 3 (by relup.sh)

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 3c0ded1
- rebuild with python 3.10

* Sun May 09 2021 Jakub Bogusz <qboosh@pld-linux.org> c78b114
- updated to 1.6.3

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> 9bfda41
- unconditional noarch subpackages

* Fri Feb 26 2021 Jan Rękorajski <baggins@pld-linux.org> c74077a
- release 2 (by relup.sh)

* Wed Dec 16 2020 Jakub Bogusz <qboosh@pld-linux.org> ee9ac7b
- updated to 1.6.2

* Fri Nov 06 2020 Jakub Bogusz <qboosh@pld-linux.org> 96eb77c
- updated to 1.6.1

* Fri Oct 16 2020 Jakub Bogusz <qboosh@pld-linux.org> 55d171d
- updated to 1.6

* Sat Sep 05 2020 Jakub Bogusz <qboosh@pld-linux.org> 42140e3
- updated to 1.5.2

* Sat May 16 2020 Jakub Bogusz <qboosh@pld-linux.org> 1628dfd
- updated to 1.5.1

* Sun Feb 09 2020 Jakub Bogusz <qboosh@pld-linux.org> 0f0641d
- updated to 1.5

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 0845a3b
- rebuild with python 3.8
- release 2 (by relup.sh)

* Sun Sep 01 2019 Jakub Bogusz <qboosh@pld-linux.org> cac9d1c
- updated to 1.4.1

* Sun Jul 21 2019 Jakub Bogusz <qboosh@pld-linux.org> 9f326f8
- updated to 1.4

* Sat Mar 30 2019 Jakub Bogusz <qboosh@pld-linux.org> b8cbe86
- updated to 1.3

* Sun Mar 10 2019 Jakub Bogusz <qboosh@pld-linux.org> fea84b9
- updated to 1.2.1

* Mon Nov 26 2018 Jakub Bogusz <qboosh@pld-linux.org> 1c234fd
- updated to 1.2

* Fri Aug 24 2018 Jakub Bogusz <qboosh@pld-linux.org> 397de19
- new

